﻿using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using System.Net.Sockets ;
using System.IO ;
//using Serializable;
using System.Runtime.Serialization; 
using System.Runtime.Serialization.Formatters.Binary; 
using System.Text;
using System.Threading;

using Protocol;

namespace cServer
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class frmMain : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.ListBox lbClients;

		//The listner for the server, which listen for the clients
		private TcpListener tcpListener;
		private Socket socketForClient;
		private Thread tServerThread;
		public  ArrayList tClientThreads;
		public Protocol.RSAKeyCreator serverKeys;
		

		private System.Data.OleDb.OleDbDataAdapter oleDbDataAdapter1;
		private System.Data.OleDb.OleDbConnection oleDbConnection1;
		private cServer.Users users1;
		private System.Data.OleDb.OleDbCommand oleDbSelectCommand1;
		private System.Data.OleDb.OleDbCommand oleDbInsertCommand1;
		private System.Data.OleDb.OleDbCommand oleDbUpdateCommand1;
		private System.Data.OleDb.OleDbCommand oleDbDeleteCommand1;
		private System.Windows.Forms.ListBox lbFiles;
		private System.Windows.Forms.ListBox lbRestricIP;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox tbRIP;
		private System.Windows.Forms.Button button4;
		private System.Windows.Forms.Label label4;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			tClientThreads = new ArrayList();
            /* You have to copy the users.mdb to the folder C:\Documents and Settings\btanveer.LHR\Desktop\Chat Application\cServer\Data\users.mdb
              or copy all folders Data, MCS, servertemp and executables cClient.exe, cServer.exe, HashPassword.exe and Protocol.dll to C:\ */
            oleDbDataAdapter1.Fill(users1);
			ClientThread.usersList = users1;
			ClientThread.serverGUI = this;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			GetMemoryBack();
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Configuration.AppSettingsReader configurationAppSettings = new System.Configuration.AppSettingsReader();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.lbClients = new System.Windows.Forms.ListBox();
			this.oleDbDataAdapter1 = new System.Data.OleDb.OleDbDataAdapter();
			this.oleDbDeleteCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbConnection1 = new System.Data.OleDb.OleDbConnection();
			this.oleDbInsertCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbSelectCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbUpdateCommand1 = new System.Data.OleDb.OleDbCommand();
			this.users1 = new cServer.Users();
			this.lbFiles = new System.Windows.Forms.ListBox();
			this.lbRestricIP = new System.Windows.Forms.ListBox();
			this.button3 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.tbRIP = new System.Windows.Forms.TextBox();
			this.button4 = new System.Windows.Forms.Button();
			this.label4 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.users1)).BeginInit();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Enabled = false;
			this.button1.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button1.Location = new System.Drawing.Point(208, 216);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(89, 23);
			this.button1.TabIndex = 0;
			this.button1.Text = "Стоп сървър";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button2.Location = new System.Drawing.Point(106, 216);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(96, 23);
			this.button2.TabIndex = 1;
			this.button2.Text = "Вкл. сървър";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// lbClients
			// 
			this.lbClients.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lbClients.Location = new System.Drawing.Point(8, 24);
			this.lbClients.Name = "lbClients";
			this.lbClients.ScrollAlwaysVisible = true;
			this.lbClients.Size = new System.Drawing.Size(304, 69);
			this.lbClients.TabIndex = 2;
			// 
			// oleDbDataAdapter1
			// 
			this.oleDbDataAdapter1.DeleteCommand = this.oleDbDeleteCommand1;
			this.oleDbDataAdapter1.InsertCommand = this.oleDbInsertCommand1;
			this.oleDbDataAdapter1.SelectCommand = this.oleDbSelectCommand1;
			this.oleDbDataAdapter1.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																										new System.Data.Common.DataTableMapping("Table", "User", new System.Data.Common.DataColumnMapping[] {
																																																				new System.Data.Common.DataColumnMapping("username", "username"),
																																																				new System.Data.Common.DataColumnMapping("password", "password")})});
			this.oleDbDataAdapter1.UpdateCommand = this.oleDbUpdateCommand1;
			// 
			// oleDbDeleteCommand1
			// 
			this.oleDbDeleteCommand1.CommandText = "DELETE FROM [User] WHERE (username = ?) AND ([password] = ? OR ? IS NULL AND [pas" +
				"sword] IS NULL)";
			this.oleDbDeleteCommand1.Connection = this.oleDbConnection1;
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_username", System.Data.OleDb.OleDbType.VarWChar, 10, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "username", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_password", System.Data.OleDb.OleDbType.VarWChar, 10, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "password", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_password1", System.Data.OleDb.OleDbType.VarWChar, 10, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "password", System.Data.DataRowVersion.Original, null));
			// 
			// oleDbConnection1
			// 
			this.oleDbConnection1.ConnectionString = ((string)(configurationAppSettings.GetValue("DBConnectionString", typeof(string))));
			// 
			// oleDbInsertCommand1
			// 
			this.oleDbInsertCommand1.CommandText = "INSERT INTO [User] (username, [password]) VALUES (?, ?)";
			this.oleDbInsertCommand1.Connection = this.oleDbConnection1;
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("username", System.Data.OleDb.OleDbType.VarWChar, 10, "username"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("password", System.Data.OleDb.OleDbType.VarWChar, 10, "password"));
			// 
			// oleDbSelectCommand1
			// 
			this.oleDbSelectCommand1.CommandText = "SELECT username, [password] FROM [User]";
			this.oleDbSelectCommand1.Connection = this.oleDbConnection1;
			// 
			// oleDbUpdateCommand1
			// 
			this.oleDbUpdateCommand1.CommandText = "UPDATE [User] SET username = ?, [password] = ? WHERE (username = ?) AND ([passwor" +
				"d] = ? OR ? IS NULL AND [password] IS NULL)";
			this.oleDbUpdateCommand1.Connection = this.oleDbConnection1;
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("username", System.Data.OleDb.OleDbType.VarWChar, 10, "username"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("password", System.Data.OleDb.OleDbType.VarWChar, 10, "password"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_username", System.Data.OleDb.OleDbType.VarWChar, 10, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "username", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_password", System.Data.OleDb.OleDbType.VarWChar, 10, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "password", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_password1", System.Data.OleDb.OleDbType.VarWChar, 10, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "password", System.Data.DataRowVersion.Original, null));
			// 
			// users1
			// 
			this.users1.DataSetName = "Users";
			this.users1.Locale = new System.Globalization.CultureInfo("en-US");
			// 
			// lbFiles
			// 
			this.lbFiles.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lbFiles.HorizontalScrollbar = true;
			this.lbFiles.Location = new System.Drawing.Point(8, 112);
			this.lbFiles.Name = "lbFiles";
			this.lbFiles.ScrollAlwaysVisible = true;
			this.lbFiles.Size = new System.Drawing.Size(304, 95);
			this.lbFiles.TabIndex = 3;
			// 
			// lbRestricIP
			// 
			this.lbRestricIP.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lbRestricIP.Location = new System.Drawing.Point(320, 24);
			this.lbRestricIP.Name = "lbRestricIP";
			this.lbRestricIP.ScrollAlwaysVisible = true;
			this.lbRestricIP.Size = new System.Drawing.Size(168, 147);
			this.lbRestricIP.TabIndex = 4;
			// 
			// button3
			// 
			this.button3.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button3.Location = new System.Drawing.Point(320, 216);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(80, 23);
			this.button3.TabIndex = 5;
			this.button3.Text = "Забрани IP";
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(8, 96);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(120, 16);
			this.label1.TabIndex = 6;
			this.label1.Text = "Списък файлове";
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label2.Location = new System.Drawing.Point(8, 8);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(184, 16);
			this.label2.TabIndex = 7;
			this.label2.Text = "Включили се потребители";
			// 
			// label3
			// 
			this.label3.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label3.Location = new System.Drawing.Point(320, 8);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(120, 16);
			this.label3.TabIndex = 8;
			this.label3.Text = "Забранени IP-та";
			// 
			// tbRIP
			// 
			this.tbRIP.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tbRIP.Location = new System.Drawing.Point(320, 184);
			this.tbRIP.Name = "tbRIP";
			this.tbRIP.Size = new System.Drawing.Size(168, 21);
			this.tbRIP.TabIndex = 9;
			this.tbRIP.Text = "";
			// 
			// button4
			// 
			this.button4.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button4.Location = new System.Drawing.Point(408, 216);
			this.button4.Name = "button4";
			this.button4.Size = new System.Drawing.Size(80, 23);
			this.button4.TabIndex = 10;
			this.button4.Text = "Разреши IP";
			this.button4.Click += new System.EventHandler(this.button4_Click);
			// 
			// label4
			// 
			this.label4.Font = new System.Drawing.Font("Arial", 6.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label4.Location = new System.Drawing.Point(8, 216);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(80, 24);
			this.label4.TabIndex = 11;
			this.label4.Text = "PhotonSoft Ltd. Daniel Denev";
			this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// frmMain
			// 
			this.AccessibleRole = System.Windows.Forms.AccessibleRole.TitleBar;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(496, 246);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.button4);
			this.Controls.Add(this.tbRIP);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.button3);
			this.Controls.Add(this.lbRestricIP);
			this.Controls.Add(this.lbFiles);
			this.Controls.Add(this.lbClients);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.Name = "frmMain";
			this.Text = "Сървър";
			((System.ComponentModel.ISupportInitialize)(this.users1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			/*
			Protocol.RSAKeyCreator keyCreator = new Protocol.RSAKeyCreator();
			Protocol.Crypto security = new Crypto(keyCreator.PublicKeyXml);
			Protocol.EncryptedDataInfo encryptedData = security.Encrypt("this is basit");

			Protocol.Crypto security2 = new Crypto(keyCreator.PrivateKeyXml);
			string retValue = security2.Decrypt(encryptedData);*/
			
			Application.Run(new frmMain());
		}
		//It updates the list of files avialable at server
		public void updateFileList()
		{
			
			//FIND ALL FILES IN FOLDER
			System.IO.DirectoryInfo dir = new System.IO.DirectoryInfo(ClientThread.defaultLocation);
			foreach (System.IO.FileInfo f in dir.GetFiles("*.*"))
			{
				ClientThread.onlineFiles.Append(f.Name+"$");
				lbFiles.Items.Add(f.Name);
			}
		}
		public void addClientToList(string client)
		{
			lbClients.Items.Add(client);
		}
		public void removeClientToList(string client)
		{
			lbClients.Items.Remove(client);
		}
		private void GetMemoryBack()
		{
			if(tServerThread != null && tServerThread.IsAlive)
			{
				tServerThread.Abort();
			}
			if(tcpListener != null)
				tcpListener.Stop();
			foreach (DictionaryEntry d in ClientThread.connectedUsers)
			{
				ClientThread clientObj = (ClientThread) d.Value;
				clientObj.closeConnections();
				clientObj = null;
			}
			for(int i=0;i<tClientThreads.Count;i++)
			{
				Thread temp = (Thread) tClientThreads[i];
				if(temp!=null && temp.IsAlive)
				{
					temp.Abort();
				}
				temp = null;
			}
		}
		private void button2_Click(object sender, System.EventArgs e)
		{
			
			string hostName = System.Net.Dns.Resolve("localhost").HostName;
			System.Net.IPAddress addr = System.Net.Dns.Resolve(hostName).AddressList[0];

			tcpListener = new TcpListener(addr,8100) ;
			tcpListener.Start() ;
			button2.Enabled = false;
			button1.Enabled = true;
			
			serverKeys = new RSAKeyCreator();
			//creates a thread for the server listening process
			updateFileList();

			tServerThread=new Thread(new ThreadStart(mainServerThreadStart));
			tServerThread.Name = "Server Thread";
			tServerThread.Start();
		}
		
		//static int  j=0;
		void mainServerThreadStart()
		{
			//listBox1.Items.Add("in tcpListener.AcceptSocket()");
			while (true)
			{
			socketForClient = tcpListener.AcceptSocket() ;
			ClientThread clientObj=new ClientThread();
			clientObj.socketForClient=socketForClient;
			//ClientThread.decrypter.LoadFromXmlKey(serverKeys.PrivateKeyXml);
		
			Thread tClientThread=new Thread(new ThreadStart(clientObj.run));
			tClientThread.Name="Client Thread";
			tClientThreads.Add (tClientThread);
			tClientThread.Start();
			}
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			
			button2.Enabled = true;
			button1.Enabled = false;

			lbClients.Items.Clear();
			lbClients.Update();

			lbFiles.Items.Clear();
			lbFiles.Update();

			lbRestricIP.Items.Clear();
			lbRestricIP.Update();

			GetMemoryBack();
		}

		public bool IsIPRestricted(string ip)
		{
			return lbRestricIP.Items.Contains(ip);
		}
		private void button3_Click(object sender, System.EventArgs e)
		{
			if(!tbRIP.Text.Equals(string.Empty))
			{
				if(!lbRestricIP.Items.Contains(tbRIP.Text.Trim()))
				{
					lbRestricIP.Items.Add(tbRIP.Text.Trim());
					tbRIP.Text = string.Empty;
				}
			}
		}

		private void button4_Click(object sender, System.EventArgs e)
		{
			if(lbRestricIP.SelectedIndex != -1)
			{
				lbRestricIP.Items.Remove(lbRestricIP.SelectedItem);
			}
		}
	}
}
